/*
 * Lame abstraction of TCP/IP networking code
 * 2002-2003 HShivanan
 *
 * For licensing terms, see the file COPYING
 * For contact infor, see the file AUTHORS
 */

#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include "net.h"
void n_close(int fd)
{
	close(fd);
}

/*useless function*/
int n_send(int fd,char *data)
{
	return sendto(fd , data, strlen(data)+1, 0, NULL, 0);
	
}


int n_sendRaw(const int fd,const char *b,const size_t l)
{
	int len,i;
	i=0;
	i=len=sendto(fd,b,l,0,NULL,0);

	/*if no data was sent, return 0*/
	if (len==0)
		return 0;

	/*if the entire data was sent in one shot, just return the
	  data length*/
	if (len==l)return l;

	/*if only part of the data was sent, keep trying to send the
	  rest*/
	if (len<l)
	{
		do
		{
			len=sendto(fd,b+i,l-i,0,NULL,0);
			i+=len;
		}while (len>0);
		return i;
	}

	/*This should not be called*/
	return l;
}

/* TODO: Add support for explicit ipaddress ("xxx.xxx.xxx.xxx") */
int n_connect(char * address,int port)
{
	int fd;
	struct protoent *protocol_information;
	struct sockaddr_in target_host_address;
	struct hostent *h;
	protocol_information=getprotobyname(DEFAULT_PROTO);
	if (protocol_information==NULL)
	{
		return NULL_PROTO;
	}
	fd=socket(AF_INET,SOCK_STREAM,0);
	if (fd<0)
	{
		return NULL_CONNECTION;
	}
	memset((void*)&target_host_address,0,sizeof(target_host_address));
	target_host_address.sin_family=AF_INET;
	target_host_address.sin_port=htons(port);
	h=gethostbyname(address);
	if (h==NULL)
	{
		return NO_CONNECTION;
	}
	target_host_address.sin_addr.s_addr=inet_addr(inet_ntoa(*((struct in_addr *)
					h->h_addr)));
	if (connect(fd,(struct sockaddr*)&target_host_address,
				sizeof(target_host_address))<0)
	{
		return NO_CONNECTION;
	}
	return fd;
}
